<template>
  <q-input dense filled v-model="searchText" label="Поиск" maxlength="15" class="mr-2 w-52" @update:model-value="useDebounce">
    <template v-slot:append>
      <q-icon v-if="searchText.length > 0" name="close" @click="clear" class="cursor-pointer" />
      <q-btn round flat icon="search">
        <q-menu>
          <div class="p-2">
            <div class="text-xl text-center">Укажите колонки</div>
            <div class="text-sm text-center">по которым будет произведен поиск</div>
          </div>
          <q-item v-for="(field, index) in fields" dense :class="{'opacity-50':field.required}">
            <q-item-section>
              <q-item-label v-html="field.label" />
            </q-item-section>
            <q-item-section side>
              <q-toggle v-model="field.check" :disable="field.required" :model-value="field.check"/>
            </q-item-section>
          </q-item>
        </q-menu>
      </q-btn>
    </template>
  </q-input>
</template>

<script>
import {ref} from 'vue'
import {useDebounce} from "../../components/useDebounce";
import api from "../../API/api";

export default {
  name: "Search-Input",
  props: {
  },
  setup(props, {emit}) {
    const fields = ref([
      // { name: 'fields', label: 'Доп. поля', check: true, required: true},
      {
        name: 'name',
        label: 'Название',
        check: false,
        required: false
      },
      { name: 'responsible', label: 'Отвественный', check: false, required: false},
      { name: 'website', label: 'Сайт', check: false, required: false},
      { name: 'phone', label: 'Телефон',  check: false, required: false},
      { name: 'city', label: 'Город',  check: false, required: false},
      { name: 'status', label: 'Статус',  check: false, required: false},
      { name: 'task', label: 'Задача', check: false, required: false},
      { name: 'budget', label: 'Бюджет', check: false, required: false},
      { name: 'prepay', label: 'Предоплата', check: false, required: false},
      { name: 'debt', label: 'Долг', check: false, required: false},
      { name: 'updatedAt', label: 'Изменен', check: false, required: false},
      { name: 'createdAt', label: 'Создан', check: false, required: false}
    ])
    const searchText = ref('')

    function selectSearchFields (index) {
      fields[index].check = !fields[index].check
    }


    return {
      fields,
      searchText,
      selectSearchFields,
      clear: () => {
        emit('clear')
        searchText.value = ''
      },
      useDebounce: useDebounce ( async function () {
        if (searchText.value.length > 3) {
          const filter = fields.value.filter(el => el.check).map(e => e.name)
          api.searchLead({val: searchText.value, field: filter})
            .then(res => emit('searchResult', res.data))
        }
      }, 500),
    }
  }
}
</script>

<style scoped lang="scss">
.botpos {
  position: absolute;
  bottom: 200px;
  @media (max-width: 1420px) {
    bottom: 250px;
  }
  @media (max-width: 1280px) {
    bottom: 300px;
  }
  @media (max-width: 1200px) {
    bottom: 250px;
  }
  @media (max-width: 850px) {
    bottom: 320px;
  }
  @media (max-width: 770px) {
    bottom: 350px;
  }
  @media (max-width: 600px) {
    bottom: 290px;
  }
  @media (max-width: 570px) {
    bottom: 310px;
  }
}
</style>
